﻿/*
* ColorCheckerGrayScaleCalibrator for ColorChecker Classic & Passport
* version 1.0
*
* Copyright (c) 2010 José Pereira.
* http://www.jpereira.net
* http://www.jpereira.net/gestion-de-color/kodak-q-13-gray-scale
 */

/*
*You can change the values of the patches to your choice from the following array:
This RGB Values By: www.BabelColor.com © 2000-2006 Danny Pascale "RGB coordinates of the Macbeth ColorChecker"
*/
var outPutValues = new Array ;
var docRef = activeDocument;
var profile = docRef.colorProfileName;

switch(profile){
	case "ProPhoto RGB":
		outPutValues[1] = 242  // 19 White
		outPutValues[2] = 102  // 22 Neutral (0.7D)
		outPutValues[3] = 37    // 24 Black
	break;
	case "sRGB IEC61966-2.1":
		outPutValues[1] = 245  // 19 White
		outPutValues[2] = 121  // 22 Neutral (0.7D)
		outPutValues[3] = 49    // 24 Black
	break;
	case "Adobe RGB (1998)":
		outPutValues[1] = 245  // 19 White
		outPutValues[2] = 120  // 22 Neutral (0.7D)
		outPutValues[3] = 52    // 24 Black
	break;
	case "Apple RGB":
		outPutValues[1] = 242  // 19 White
		outPutValues[2] = 101  // 22 Neutral (0.7D)
		outPutValues[3] = 37    // 24 Black
	break;
	default:
	alert("For better results your image should be converted to one of these profiles: ProPhoto RGB, sRGB IEC61966-2.1, Apple RGB, Adobe RGB (1998)")
		// default values.
		outPutValues[1] = 242  // 19 White
		outPutValues[2] = 101  // 22 Neutral (0.7D)
		outPutValues[3] = 37    // 24 Black	
	break;
}

var channels = new Array;
	channels[0] = "Rd  ";
	channels[1] = "Grn ";
	channels[2] = "Bl  ";

if (documents.length == 0) {
    alert("No documents are open!.");
}else {
	

	if (docRef.mode != DocumentMode.RGB) {
        docRef.changeMode(ChangeMode.RGB);
	   } 
     	 
		try {
			   var nsamples = docRef.colorSamplers.length;
			   if (docRef.colorSamplers.length == 3) {
					var inputValues = new Array();
					for(j=0; j< nsamples; j++) {
						inputValues[j] = dameMuestra(j);
					}
				   creaPuntos(inputValues, nsamples);
				}else{
					alert("You need  3 samples of color on the patches 19, 22 and 24");
					}
			         
		 }catch (e) {
				alert("There were some errors");  
				
			  }
}


function creaPuntos(inputValues, nsamples ){

	var curvePoints = new Array();
	var chn = new Array();
	var inicio = 0;
	var factor = 0;
	var entrada = 0;

		curvePoints[0] = [Array(0,0),Array(0,0),Array(0,0)];
		inicio = 1;
		factor  = 1;

for(i=inicio; i< nsamples+1; i++) {

		for(j=0; j< 3; j++) {
			
			entrada = inputValues[i-1][j];
			if (entrada < 4){ entrada = 4; }
			chn[j] = Array( inputValues[i-1][j], outPutValues[i] );	
		}
	curvePoints[i] =  Array(chn[0], chn[1], chn[2]) ;
	}

		curvePoints[nsamples+1] = [Array(255,255),Array(255,255),Array(255,255)]; 
	

	activeDocument.activeLayer=docRef.backgroundLayer; 
	makeCurveAdjustmentLayer(curvePoints);

	}

function dameMuestra(sample){
    var red, green, blue;
	var output = Array();
    var docRef = activeDocument;
		 docRef.activeLayer=docRef.backgroundLayer; 

	var colorSamplerRef = docRef.colorSamplers[sample];
	var currentColor = colorSamplerRef.color;

	var red = parseInt(currentColor.rgb.red); 
	var green = parseInt(currentColor.rgb.green);
	var blue = parseInt(currentColor.rgb.blue);
	output[0] = red;
	output[1] = green;
	output[2] = blue;
	return output;
	
}


/*******************
Create a Curves Adjustment Layer 	
*******************/

function makeCurveAdjustmentLayer (curvePoints){

Array.prototype.inArray = function (value){
	var i;

	for (i=0; i < this.length; i++) {
	if (this[i] === value) {
	return true;
	}
	}
	return false;
};

    var desc14 = new ActionDescriptor();
        var ref9 = new ActionReference();
        ref9.putClass( charIDToTypeID( "AdjL" ) );
		desc14.putReference( charIDToTypeID( "null" ), ref9 );
			var desc15 = new ActionDescriptor();
				var desc16 = new ActionDescriptor();
					var list1 = new ActionList();			  
  					  var controlArray = new Array();
					 
						/*******************
						Set  Points on  the RED channel 	
						*******************/
						
							var descRed = new ActionDescriptor();
                               var refRed = new ActionReference();
							refRed.putEnumerated(charIDToTypeID( "Chnl" ), charIDToTypeID( "Chnl" ),  charIDToTypeID(channels[0] ) );
							descRed.putReference(charIDToTypeID( "Chnl" ), refRed);
							var list2 = new ActionList();
							curvePoints.sort(function mysortfn(a,b) { return ((parseFloat(a[0]) < parseFloat(b[0])) ? -1 : ((parseFloat(a[0]) > parseFloat(b[0])) ? 1 : 0));});							
							for(i=0;i<curvePoints.length;i++){
								if ( !controlArray.inArray(curvePoints[i][0][0] )){
										
										var descPred = new ActionDescriptor();
										descPred.putDouble( charIDToTypeID( "Hrzn" ), curvePoints[i][0][0] );
										descPred.putDouble( charIDToTypeID( "Vrtc" ), curvePoints[i][0][1] );
										list2.putObject( charIDToTypeID( "Pnt " ), descPred );
										}
										controlArray[i] = curvePoints[i][0][0];
										
							}
							descRed.putList( charIDToTypeID( "Crv " ), list2 );
							list1.putObject( charIDToTypeID( "CrvA" ), descRed );
					  	     /*******************
								Set  Points on  the Green channel 	
							 *******************/
							var descGreen = new ActionDescriptor();
                               var refGreen = new ActionReference();
							refGreen.putEnumerated(charIDToTypeID( "Chnl" ), charIDToTypeID( "Chnl" ),  charIDToTypeID(channels[1] ) );
							descGreen.putReference(charIDToTypeID( "Chnl" ), refGreen);
							var list2 = new ActionList();
							var controlArray = [];
							curvePoints.sort(function mysortfn(a,b) { return ((parseFloat(a[1]) < parseFloat(b[1])) ? -1 : ((parseFloat(a[1]) > parseFloat(b[1])) ? 1 : 0));});
								for(i=0;i<curvePoints.length;i++){
									if ( !controlArray.inArray(curvePoints[i][1][0] )){
									var descPgreen = new ActionDescriptor();
									descPgreen.putDouble( charIDToTypeID( "Hrzn" ), curvePoints[i][1][0] );
									descPgreen.putDouble( charIDToTypeID( "Vrtc" ), curvePoints[i][1][1] );
									list2.putObject( charIDToTypeID( "Pnt " ), descPgreen );
									}
										controlArray[i] = curvePoints[i][1][0];
							}
							descGreen.putList( charIDToTypeID( "Crv " ), list2 );
							list1.putObject( charIDToTypeID( "CrvA" ), descGreen );
					     	/*******************
							Set Points on the Blue channel 	
							*******************/			
							var descBlue = new ActionDescriptor();
                               var refBlue = new ActionReference();
							refBlue.putEnumerated(charIDToTypeID( "Chnl" ), charIDToTypeID( "Chnl" ),  charIDToTypeID(channels[2] ) );
							descBlue.putReference(charIDToTypeID( "Chnl" ), refBlue);
							var list2 = new ActionList();
						    var controlArray = [];
							curvePoints.sort(function mysortfn(a,b) { return ((parseFloat(a[2] )< parseFloat(b[2])) ? -1 : ((parseFloat(a[2]) > parseFloat(b[2])) ? 1 : 0));});
								for(i=0;i<curvePoints.length;i++){
									if ( !controlArray.inArray(curvePoints[i][2][0] )){
									var descPblue = new ActionDescriptor();
									descPblue.putDouble( charIDToTypeID( "Hrzn" ), curvePoints[i][2][0] );
									descPblue.putDouble( charIDToTypeID( "Vrtc" ), curvePoints[i][2][1] );
									list2.putObject( charIDToTypeID( "Pnt " ), descPblue );	
									}
										controlArray[i] = curvePoints[i][2][0];
							}
                            descBlue.putList( charIDToTypeID( "Crv " ), list2 );
						 list1.putObject( charIDToTypeID( "CrvA" ), descBlue );
						 
					/*********  Finish the settings *********/
				
				   var desc11 = new ActionDescriptor();	
            desc16.putList( charIDToTypeID( "Adjs" ), list1 );
        desc15.putObject( charIDToTypeID( "Type" ), charIDToTypeID( "Crvs" ), desc16 );
    desc14.putObject( charIDToTypeID( "Usng" ), charIDToTypeID( "AdjL" ), desc15 );
executeAction( charIDToTypeID( "Mk  " ), desc14, DialogModes.NO );
  
}

